=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# There are no upstream tarballs yet
