=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.3 2020/01/16 11:41:14 bluhm Exp $

SUBDIR=	test_helper dh parser live

.include <bsd.subdir.mk>
