=== debian/changelog ===
openiked (7.0-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 16:04:21 +0100

openiked (7.0-1) unstable; urgency=medium

  * New upstream release
  * Update watch file to point to tarballs on FTP mirror

 -- Ryan Kavanagh <rak@debian.org>  Thu, 04 Nov 2021 12:32:35 -0400

openiked (6.9.0-2) unstable; urgency=medium

  * Bump standards version to 4.6.0
  * Delete files under /etc/iked created by openiked on purge

 -- Ryan Kavanagh <rak@debian.org>  Sat, 18 Sep 2021 21:27:42 -0400
