## openiked 7.1

=== debian/changelog ===
openiked (7.1-1build1) kinetic; urgency=medium

  * No-change rebuild against libevent-2.1-7a (LP: #1990941)

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 07 Oct 2022 19:54:06 +0200

openiked (7.1-1) unstable; urgency=medium

  * New upstream release
  * Bump copyright years

 -- Ryan Kavanagh <rak@debian.org>  Mon, 23 May 2022 14:28:57 -0400
