=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openiked
 Section: net
 Priority: optional
-Maintainer: Ryan Kavanagh <rak@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ryan Kavanagh <rak@debian.org>
 Build-Depends: bison,
                cmake,
                debhelper-compat (= 13),
