## openiked 7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2020-2021 Tobias Heider <tobhe@openbsd.org>
+# Copyright (c) 2020-2022 Tobias Heider <tobhe@openbsd.org>
 #
 # Permission to use, copy, modify, and distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
@@ -20,16 +20,29 @@
 include(CheckLibraryExists)
 include(CheckSymbolExists)
 include(CheckIncludeFiles)
+include(CheckLinkerFlag)
 
 include_directories("/usr/local/include")
 link_directories("/usr/local/lib")
 
 if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
 	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
-		set (CMAKE_INSTALL_SYSCONFDIR /etc)
-	endif()
-	include_directories("/usr/local/opt/openssl@1.1/include")
-	link_directories("/usr/local/opt/openssl@1.1/lib")
+		set (CMAKE_INSTALL_SYSCONFDIR ${CMAKE_INSTALL_PREFIX}/etc)
+	endif()
+	add_definitions(-DIKED_CONFIG="${CMAKE_INSTALL_SYSCONFDIR}/iked.conf")
+	add_definitions(-DIKED_CA="${CMAKE_INSTALL_SYSCONFDIR}/iked/")
+	add_definitions(-DHAVE_APPLE_NATT)
+	add_definitions(-DHAVE_SOCKADDR_SA_LEN)
+	if (HOMEBREW AND CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "arm64")
+		include_directories("/opt/homebrew/include")
+		link_directories("/opt/homebrew/lib")
+		include_directories("/opt/homebrew/opt/openssl@1.1/include")
+        	link_directories("/opt/homebrew/opt/openssl@1.1/lib")
+	else()
+		include_directories("/usr/local/opt/openssl@1.1/include")
+		link_directories("/usr/local/opt/openssl@1.1/lib")
+	endif()
+	set(HAVE_VROUTE ON)
 elseif(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
 	if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
 		set (CMAKE_INSTALL_SYSCONFDIR /etc)
@@ -65,10 +78,13 @@
 	add_definitions(-DHAVE_UDPENCAP6)
 	add_definitions(-DSPT_TYPE=SPT_REUSEARGV)
 	set(HAVE_VROUTE_NETLINK ON)
+	set(HAVE_SYSTEMD ON)
 endif()
 if (NOT DEFINED CMAKE_INSTALL_MANDIR)
 	set (CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_PREFIX}/man)
 endif()
+
+check_linker_flag(C "LINKER:-z,now,-z,relro" HAVE_LD_Z)
 
 check_include_files("sys/types.h;net/pfkeyv2.h" HAVE_NET_PFKEY_H)
 if(HAVE_NET_PFKEY_H)
@@ -341,11 +357,25 @@
 if(HAVE_GETOPT)
         add_definitions(-DHAVE_GETOPT)
 endif()
-if(HAVE_VROUTE)
+if(HAVE_SYSTEMD)
+	add_definitions(-DHAVE_SYSTEMD)
+endif()
+if(HAVE_VROUTE OR HAVE_VROUTE_NETLINK)
 	add_definitions(-DHAVE_VROUTE)
 endif()
-if(HAVE_VROUTE_NETLINK)
-	add_definitions(-DHAVE_VROUTE_NETLINK)
+if(WITH_APPARMOR)
+	add_definitions(-DWITH_APPARMOR)
+endif()
+
+if(ASAN)
+	message("Using ASAN")
+	string(APPEND CMAKE_C_FLAGS " -fno-omit-frame-pointer -fsanitize=address")
+	string(APPEND CMAKE_LINKER_FLAGS " -fno-omit-frame-pointer -fsanitize=address")
+endif()
+if(UBSAN)
+	message("Using UBSAN")
+	string(APPEND CMAKE_C_FLAGS " -fno-omit-frame-pointer -fsanitize=undefined")
+	string(APPEND CMAKE_LINKER_FLAGS " -fno-omit-frame-pointer -fsanitize=undefined")
 endif()
 
 add_subdirectory(compat)
@@ -353,7 +383,7 @@
 add_subdirectory(ikectl)
 add_subdirectory(regress/dh)
 add_subdirectory(regress/parser)
-if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND CMAKE_C_COMPILER_ID STREQUAL "Clang")
+if(CLUSTERFUZZ)
 	add_subdirectory(regress/parser-libfuzzer)
 endif()
 add_subdirectory(regress/test_helper)
