=== ikectl/CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,9 @@
 set(CFLAGS)
 list(APPEND CFLAGS
 	-O2
+	-fstack-protector-strong
+	-fPIE
+	-D_FORTIFY_SOURCE=2
 	-Wall
 	-Wno-pointer-sign
 	-Wno-deprecated-declarations
@@ -41,6 +44,9 @@
 )
 
 target_compile_options(ikectl PRIVATE ${CFLAGS})
+if(HAVE_LD_Z)
+	target_link_options(ikectl PRIVATE "LINKER:-z,relro,-z,now")
+endif()
 
 target_include_directories(ikectl
 	PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
