=== regress/test_helper/Makefile ===
#	$OpenBSD: Makefile,v 1.1 2017/05/29 20:59:32 markus Exp $

LIB=	test_helper
SRCS=	test_helper.c

DEBUGLIBS= no
NOPROFILE= yes
NOPIC=	yes

install:
	@echo -n

.include <bsd.lib.mk>
