=== debian/changelog ===
openiked (7.2-1) unstable; urgency=medium

  * New upstream release.

  [ Tobias Heider ]
  * Add myself to Uploaders.

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Ryan Kavanagh ]
  * Update lintian overrides to deal with renamed tags

 -- Ryan Kavanagh <rak@debian.org>  Tue, 10 Jan 2023 16:02:50 -0500
