=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: openiked
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ryan Kavanagh <rak@debian.org>
+Maintainer: Ryan Kavanagh <rak@debian.org>
+Uploaders: Tobias Heider <me@tobhe.de>
 Build-Depends: bison,
                cmake,
                debhelper-compat (= 13),
                libevent-dev,
                libssl-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://www.openiked.org/
 Vcs-Browser: https://salsa.debian.org/debian/openiked
 Vcs-Git: https://salsa.debian.org/debian/openiked.git -b debian/unstable
